//Q0 I/O Class
//
//Load 24bit 
//
//

unit Q0Pack;

interface
uses
  Windows,SysUtils, Classes, Graphics;

type
  TQ0 = class(TBitmap)
  private
   procedure GetSize(FileName:String);
  public
   procedure LoadFromFile(const FileName: string); override;
end;


type
 pRGBArray =^TRGBArray;
 TRGBArray =array [0..0] of TRGBTriple;

implementation

////////
procedure TQ0.GetSize(FileName:String);
Var
  BitsStream : TMemoryStream;
  InfoStream : TStringStream;
  Q0Width,Q0Height :integer;
  Size :String;
begin
  BitsStream:=TMemoryStream.Create;
  InfoStream:=TStringStream.Create('');
  BitsStream.LoadFromFile(FileName);
  InfoStream.CopyFrom(BitsStream,0);
  InfoStream.Position:=14;
  Size:=Trim(InfoStream.ReadString(6));
  Q0Width:= StrToIntDef(Size,0);
  Size:=Trim(InfoStream.ReadString(6));
  Q0Height:= StrToIntDef(Size,0);
  if (Q0Width=0) or (Q0Height=0) then
  begin
    BitsStream.Free;
    InfoStream.Free;
    raise Exception.Create('C[WTCYsłB')
  end
  else
  begin
    Width:=Q0Width;
    Height:=Q0Height;
    Pixelformat:=pf24bit;
  end;
  InfoStream.free;
  BitsStream.free;
end;

/////////
procedure TQ0.LoadFromFile(const FileName: string);
Var
 FAL :string;
 BitsStream : TMemoryStream;
 Row,COl    : Integer;
 SrcRow     : pRGBArray;
 Buffer     : Pointer;
 MemPointer : PByte;
begin
  //FALt@CȂꍇ͏I
  FAL:=ChangeFileExt(FileName,'.fal') ;
  if not FileExists(FAL) then
    raise Exception.Create('FALt@C܂B')
  else
    GetSize(FAL);

  BitsStream:=TMemoryStream.Create;
  BitsStream.LoadFromFile(FileName);

  //t@C̓K`FbN
  if BitsStream.size<>Width*Height*3 then
  begin
   BitsStream.Free;
   raise Exception.Create('t@CsłB')
  end;

  //m
  GetMem(Buffer,BitsStream.size);
try
  MoveMemory(Buffer,BitsStream.Memory,BitsStream.size);
  MemPointer:=PBYTE(Buffer);

  For  Row:=0 to Height-1 do
  begin
    SrcRow:=ScanLine[Row];
    For Col:=0 to Width-1 do
    begin
     SrcRow[Col].rgbtRed :=MemPointer^;
     inc(MemPointer) ;
     SrcRow[Col].rgbtGreen:=MemPointer^;
     inc(MemPointer);
     SrcRow[Col].rgbtBlue :=MemPointer^;
     inc(MemPointer)
    end;
  end;

finally
 BitsStream.free;
 Freemem(Buffer);
end;
end;

initialization
  TPicture.RegisterFileFormat('Q0', 'Nifty-Server Format', TQ0);

finalization
   TPicture.UnregisterGraphicClass(TQ0);


end.
